/*
* Copyright (c) 2005 X.Org Foundation L.L.C.
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
* 
* Copyright (c) Applied Testing and Technology, Inc. 1995
* All Rights Reserved.
* 
* 
* Portions of this software are based on Xlib and X Protocol Test Suite.
* We have used this material under the terms of its copyright, which grants
* free use, subject to the conditions below.  Note however that those
* portions of this software that are based on the original Test Suite have
* been significantly revised and that all such revisions are copyright (c)
* 1995 Applied Testing and Technology, Inc.  Insomuch as the proprietary
* revisions cannot be separated from the freely copyable material, the net
* result is that use of this software is governed by the ApTest copyright.
* 
* Copyright (c) 1990, 1991  X Consortium
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
* X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
* AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
* CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
* 
* Except as contained in this notice, the name of the X Consortium shall not be
* used in advertising or otherwise to promote the sale, use or other dealings
* in this Software without prior written authorization from the X Consortium.
* 
* Permission to use, copy, modify, distribute, and sell this software and
* its documentation for any purpose is hereby granted without fee,
* provided that the above copyright notice appear in all copies and that
* both that copyright notice and this permission notice appear in
* supporting documentation, and that the name of UniSoft not be
* used in advertising or publicity pertaining to distribution of the
* software without specific, written prior permission.  UniSoft
* makes no representations about the suitability of this software for any
* purpose.  It is provided "as is" without express or implied warranty.
* 
*/
/*
 * SYNOPSIS:
 *   XModifierKeymap *
 *   XInsertModifiermapEntry(modmap, keycode_entry, modifier)
 *   XModifierKeymap	*modmap;
 *   KeyCode	keycode_entry;
 *   int 	modifier;
 */


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	"xtest.h"
#include	"X11/Xlib.h"
#include	"X11/Xutil.h"
#include	"X11/Xresource.h"
#include	"X11/keysym.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
#ifdef INPUTEXTENSION
#include        "X11/extensions/XInput.h"
#include        "XItest.h"
#endif

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XInsertModifiermapEntry	1
char    *TestName = "XInsertModifiermapEntry";

/*
 * Defines for different argument types
 */


/*
 * Arguments to the XInsertModifiermapEntry function
 */
static XModifierKeymap	*modmap;
static KeyCode	keycode_entry;
static int 	modifier;



static XModifierKeymap	*Modmap;


int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	modmap = Modmap;
	keycode_entry = 0;
	modifier = 0;
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

static void t001(){

struct	kcmod {
	KeyCode	kc;
	int 	mod;
	int 	found;
};
static	struct	kcmod	kcmod[] = {
	{0x34, ShiftMapIndex},
	{0x56, Mod3MapIndex},
	{0x76, ControlMapIndex},
	{0x77, ControlMapIndex},
	{0xF6, Mod3MapIndex},
};
int 	i;
int 	set;
int 	pass = 0, fail = 0;

 	report_purpose(1);

	report_assertion("Assertion XInsertModifiermapEntry-1.(A)");
	report_assertion("A call to XInsertModifiermapEntry adds the specified");
	report_assertion("KeyCode, keycode_entry, to the set that controls the");
	report_assertion("specified modifier and returns a pointer to the modified");
	report_assertion("XModifierKeymap structure.");

	report_strategy("Create new modifiermap.");
	report_strategy("Insert several entries into the map with XInsertModifiermapEntry.");
	report_strategy("Verify by direct inspection that entries have been added.");

	tpstartup();
	setargs();
	modmap = XNewModifiermap(0);
	if (modmap == 0) {
		delete("Could not create modifiermap");
		return;
	}

	for (i = 0; i < NELEM(kcmod); i++) {
		keycode_entry = kcmod[i].kc;
		modifier = kcmod[i].mod;

		startcall(Dsp);
		if (isdeleted())
			return;
		modmap = XInsertModifiermapEntry(modmap, keycode_entry, modifier);
		endcall(Dsp);
		if (geterr() != Success) {
			report("Got %s, Expecting Success", errorname(geterr()));
			FAIL;
		}

		kcmod[i].found = 0;
	}

	for (i = 0; i < NELEM(kcmod); i++) {
		/* Look in the map */
		for (set = 0; set < modmap->max_keypermod; set++) {
			if (modmap->modifiermap[kcmod[i].mod*modmap->max_keypermod+set]==kcmod[i].kc)
				kcmod[i].found++;
		}
	}

	for (i = 0; i < NELEM(kcmod); i++) {
		if (kcmod[i].found)
			CHECK;
		else {
			report("Keycode 0x%x, modifier %s not added to map",
				kcmod[i].kc, modifiername(kcmod[i].mod));
			FAIL;
		}
	}

	CHECKPASS(NELEM(kcmod));
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	{ t001, 1 },
	{ NULL, 0 }
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
